SystemOrganization addCategory: #'SDL-Specs-Core'!

Object subclass: #SDLAPIData
	instanceVariableNames: 'functions enums structs api headerFileName unions missingTypes unknownTypes'
	classVariableNames: 'SDL'
	poolDictionaries: ''
	category: 'SDL-Specs-Core'!

!SDLAPIData commentStamp: 'NickAlexander 1/8/2012 20:04' prior: 0!
dir := '/Users/ncalexan/Pharo/SDL/'.
SDLAPIData parseAll: dir.
(SDLFFICodeGenerator on: SDLAPIData sdl) writeFileInsToDirectory: dir.

(FileStream oldFileNamed: dir, 'FFISDL.st') fileIn.!

!SDLAPIData class methodsFor: 'as yet unclassified' stamp: 'NickAlexander 1/1/2012 21:15'!
headers
	^ #('SDL.h' 'SDL_types.h' 'SDL_video.h' 'SDL_version.h' 'SDL_error.h' 'SDL_keyboard.h' 'SDL_keycode.h' 'SDL_scancode.h' 'SDL_mouse.h' 'SDL_joystick.h' 'SDL_events.h' 'SDL_timer.h' 'SDL_pixels.h' 'SDL_rect.h' 'SDL_surface.h' 'SDL_blendmode.h')! !

!SDLAPIData class methodsFor: 'as yet unclassified' stamp: ''!
parseAll: directory 
	self reset.
	self headers
		do: [:header | self sdl
				parse: (XMLDOMParser parseFileNamed: directory , '/' , header , '.xml')
				intoCategory: header].
	^ self sdl! !

!SDLAPIData class methodsFor: 'as yet unclassified' stamp: ''!
reset
	SDL := nil! !

!SDLAPIData class methodsFor: 'accessing' stamp: ''!
sdl
	^ SDL
		ifNil: [SDL := SDLAPIData new api: 'sdl']! !

!SDLAPIData methodsFor: 'srcml parsing' stamp: 'NickAlexander 1/3/2012 12:43'!
addDefine: aString value: anInteger
	| enum |
	enum := self enums
		at: 'anonymousDefinesFor', self headerFileName
		ifAbsentPut: [ SDLEnumSpec new
			headerFileName: self headerFileName;
			name: 'PreprocessorDefinesFor', (self headerFileName copyReplaceAll: '.' with: '_');
			yourself ].
	enum add: aString value: anInteger.! !

!SDLAPIData methodsFor: 'accessing' stamp: ''!
api
	^ api! !

!SDLAPIData methodsFor: 'accessing' stamp: ''!
api: anObject 
	api := anObject! !

!SDLAPIData methodsFor: 'accessing' stamp: 'NickAlexander 1/1/2012 17:56'!
enums
	^ enums! !

!SDLAPIData methodsFor: 'accessing' stamp: 'NickAlexander 1/1/2012 17:56'!
enums: anObject
	enums := anObject! !

!SDLAPIData methodsFor: 'accessing' stamp: 'NickAlexander 1/1/2012 17:56'!
functions
	^ functions! !

!SDLAPIData methodsFor: 'accessing' stamp: 'NickAlexander 1/1/2012 17:56'!
functions: anObject
	functions := anObject! !

!SDLAPIData methodsFor: 'accessing' stamp: ''!
headerFileName
	^ headerFileName! !

!SDLAPIData methodsFor: 'accessing' stamp: ''!
headerFileName: anObject 
	headerFileName := anObject! !

!SDLAPIData methodsFor: 'initialization' stamp: ''!
initialize
	enums := OrderPreservingDictionary new.
	functions := OrderPreservingDictionary new.
	structs := OrderPreservingDictionary new.
	unions := OrderPreservingDictionary new.
	unknownTypes := Set new! !

!SDLAPIData methodsFor: 'accessing' stamp: 'NickAlexander 1/1/2012 21:27'!
knownMissingTypes
	^ {#void -> #void. #Uint8 -> #byte. #Uint16 -> #ushort. #Uint32 -> #ulong. #Uint64 -> #ulonglong. #int -> #long. #SDL_bool -> #char. #SDL_Window -> #SDL_Window. #SDL_errorcode -> #long. #SDL_GLattr -> #long. #SDL_GLContext -> #SDL_GLContext. #SDL_EventFilter -> #SDL_EventFilter. #SDL_Scancode -> #long. #SDL_Keycode -> #long. #SDL_Cursor -> #SDL_Cursor. #SDL_Joystick -> #SDL_Joystick. #Sint8 -> #char. #Sint16 -> #short. #Sint32 -> #long. #Sint64 -> #longlong. #SDL_TimerID -> #long. #SDL_TimerCallback -> #SDL_TimerCallback. #SDL_RWops -> #SDL_RWops. #SDL_TouchID -> #longlong. #SDL_FingerID -> #longlong. #SDL_GestureID -> #longlong. #SDL_SysWMmsg -> #SDL_SysWMmsg. #SDL_BlitMap -> #SDL_BlitMap. #SDL_PixelFormat -> #SDL_PixelFormat. #SDL_Keymod -> #long }! !

!SDLAPIData methodsFor: 'accessing' stamp: ''!
missingTypes
	^ missingTypes
		ifNil: [missingTypes := OrderPreservingDictionary new.
			self knownMissingTypes
				do: [:each | missingTypes add: each].
			missingTypes]! !

!SDLAPIData methodsFor: 'accessing' stamp: ''!
missingTypes: anObject 
	missingTypes := anObject! !

!SDLAPIData methodsFor: 'srcml parsing' stamp: 'NickAlexander 1/3/2012 12:14'!
parse: xml intoCategory: aString 
	self headerFileName: aString.
	xml root // #typedef // #enum
		do: [:e | self parseEnum: e].
	xml root // #typedef // #struct
		do: [:e | self parseStruct: e].
	xml root // #typedef // #union
		do: [:e | self parseUnion: e].
	xml root // #function_decl
		do: [:e | self parseFunction: e].
	xml root // #cpp:define
		do: [:e | self parseDefine: e ].
	self headerFileName: nil! !

!SDLAPIData methodsFor: 'srcml parsing' stamp: 'NickAlexander 1/3/2012 12:36'!
parseDefine: xml
	| nm value td ivalue |
	nm := (xml // #name) getContentAsString.
	(xml stringNodes size < 2) ifTrue: [ ^ self ].
	value := xml stringNodes last string withBlanksTrimmed.
	ivalue := SqNumberParser
				parse: (value copyReplaceAll: '0x' with: '16r')
				onError: [ ^ self ].
	self addDefine: nm value: ivalue.
! !

!SDLAPIData methodsFor: 'srcml parsing' stamp: ''!
parseEnum: xml 
	| td |
	td := SDLEnumSpec new headerFileName: headerFileName;
				 parse: xml.
	enums at: td name put: td! !

!SDLAPIData methodsFor: 'srcml parsing' stamp: ''!
parseFunction: xml 
	| fn |
	fn := SDLFunctionSpec new headerFileName: headerFileName;
				 parse: xml.
	functions at: fn name put: fn! !

!SDLAPIData methodsFor: 'srcml parsing' stamp: ''!
parseStruct: xml 
	| td |
	td := SDLStructSpec new headerFileName: headerFileName;
				 parse: xml.
	structs at: td name put: td! !

!SDLAPIData methodsFor: 'srcml parsing' stamp: ''!
parseUnion: xml 
	| td |
	td := SDLUnionSpec new headerFileName: headerFileName;
				 parse: xml.
	unions at: td name put: td! !

!SDLAPIData methodsFor: 'accessing' stamp: 'NickAlexander 1/1/2012 17:56'!
structs
	structs
		removeKey: 'SDL_TextEditingEvent'
		ifAbsent: [].
	structs
		removeKey: 'SDL_TextInputEvent'
		ifAbsent: [].
	structs
		removeKey: 'SDL_PixelFormat'
		ifAbsent: [].
	^ structs! !

!SDLAPIData methodsFor: 'accessing' stamp: 'NickAlexander 1/1/2012 17:56'!
structs: anObject
	structs := anObject! !

!SDLAPIData methodsFor: 'accessing' stamp: 'NickAlexander 1/1/2012 17:56'!
unions
	^ unions! !

!SDLAPIData methodsFor: 'accessing' stamp: 'NickAlexander 1/1/2012 17:56'!
unions: anObject
	unions := anObject! !

Object subclass: #SDLCodeGenerator
	instanceVariableNames: 'api'
	classVariableNames: 'SDL'
	poolDictionaries: ''
	category: 'SDL-Specs-Core'!

!SDLCodeGenerator class methodsFor: 'initialize-release' stamp: 'NickAlexander 1/1/2012 18:01'!
on: api
	^ (self new) api: api; yourself! !

!SDLCodeGenerator methodsFor: 'accessing' stamp: 'NickAlexander 1/1/2012 17:59'!
api
	^ api! !

!SDLCodeGenerator methodsFor: 'accessing' stamp: 'NickAlexander 1/1/2012 17:59'!
api: anObject
	api := anObject! !

!SDLCodeGenerator methodsFor: 'accessing' stamp: 'NickAlexander 1/1/2012 19:10'!
category
	^ 'SDL-', self prefixString! !

!SDLCodeGenerator methodsFor: 'FFI code generation' stamp: 'NickAlexander 1/3/2012 12:36'!
constantsInto: aStream forClass: aClassName 
	aStream nextPutAll: 'SharedPool subclass: #' , aClassName , '
	instanceVariableNames: ''''
	classVariableNames: '''
			, (' '
					join: (api enums
							collect: [:e | ' ' join: e valueNames keys])) , '''
	poolDictionaries: ''''
	category: ''' , self category , '''.!!';
		 cr;
		 cr.
	api enums
		do: [:e | aStream nextPutAll: (self sourceForEnum: e forClass: aClassName) ].
	aStream nextPut: $!!;
		 nextPutAll: aClassName , ' class';
		 nextPutAll: ' methodsFor: ''';
		 nextPutAll: 'initialize-release';
		 nextPutAll: ''' stamp: ''';
		 nextPutAll: Author changeStamp;
		 nextPutAll: '''!!';
		 cr.
	aStream nextPutAll: 'initialize';
		 crtab;
		 nextPutAll: '"This method was automatically generated from the SDL 1.3 headers"';
		 crtab;
		 nextPutAll: '"See http://squeaksource.com/SDL-Specs for details"';
		 crtab.
	api enums
		keysDo: [:k |
			| e |
			e := api enums at: k.
			e indexesAndSuffixesDo: [:i :s | aStream crtab; nextPutAll: 'self initialize' , e name , s , '.']].
	aStream crtab; crtab; nextPutAll: '!! !!'.
	aStream cr; cr; nextPutAll: aClassName , ' initialize. !!'; cr! !

!SDLCodeGenerator methodsFor: 'FFI code generation' stamp: 'NickAlexander 1/1/2012 18:02'!
functionsInto: aStream forClass: aClassName 
	self subclassResponsibility! !

!SDLCodeGenerator methodsFor: 'FFI code generation' stamp: 'NickAlexander 1/8/2012 17:31'!
handles
	^  #(#SDL_Window #SDL_GLContext #SDL_EventFilter #SDL_Cursor #SDL_Joystick #SDL_TimerCallback #SDL_RWops #SDL_SysWMmsg #SDL_BlitMap #SDL_PixelFormat)! !

!SDLCodeGenerator methodsFor: 'FFI code generation' stamp: 'NickAlexander 1/1/2012 18:02'!
handlesInto: aStream forClass: aClassName 
	self subclassResponsibility! !

!SDLCodeGenerator methodsFor: 'FFI code generation' stamp: 'NickAlexander 1/8/2012 19:07'!
loaderInto: aStream forDirectory: aString
	aStream
		nextPutAll: '(FileStream oldFileNamed: ''', aString, self prefixString, 'SDLConstants.st', ''') fileIn. !!';
		cr;
		nextPutAll: '(FileStream oldFileNamed: ''', aString, self prefixString, 'SDLHandles.st', ''') fileIn. !!';
		cr;
		nextPutAll: '(FileStream oldFileNamed: ''', aString, self prefixString, 'SDLStructs.st', ''') fileIn. !!';
		cr;
		nextPutAll: '(FileStream oldFileNamed: ''', aString, self prefixString, 'SDLFunctions.st', ''') fileIn. !!'.
! !

!SDLCodeGenerator methodsFor: 'accessing' stamp: 'NickAlexander 1/1/2012 19:08'!
prefixString
	self subclassResponsibility! !

!SDLCodeGenerator methodsFor: 'FFI code generation' stamp: 'NickAlexander 1/1/2012 19:09'!
readFileIns
	(FileStream oldFileNamed: self prefixString, 'SDLConstants.st') fileIn.
	(FileStream oldFileNamed: self prefixString, 'SDLHandles.st') fileIn.
	(FileStream oldFileNamed: self prefixString, 'SDLStructs.st') fileIn.
	(FileStream oldFileNamed: self prefixString, 'SDLFunctions.st') fileIn! !

!SDLCodeGenerator methodsFor: 'code generation' stamp: 'NickAlexander 1/2/2012 23:02'!
sourceForEnum: e forClass: aClassName
	| index |
	^ String streamContents: [ :aStream |
	aStream nextPut: $!!;
		 nextPutAll: aClassName , ' class';
		 nextPutAll: ' methodsFor: ''';
		 nextPutAll: e headerFileName;
		 nextPutAll: ''' stamp: ''';
		 nextPutAll: Author changeStamp;
		 nextPutAll: '''!!';
		 cr.
	e
		indexesAndSuffixesDo: [:i :s | 
			aStream nextPutAll: 'initialize' , e name , s;
				 crtab;
				 nextPutAll: '"This method was automatically generated from SDL 1.3 headers"';
				 crtab;
				 nextPutAll: '"See http://squeaksource.com/SDLSpecs for details"';
				 crtab.
			(e valueNames keys
				copyFrom: i
				to: (e valueNames size min: i + 100))
				do: [:k | 
					| v |
					v := e valueNames at: k.
					aStream crtab; nextPutAll: k; nextPutAll: ' := ';
						nextPutAll: (e isHex
								ifTrue: [v hex]
								ifFalse: [v asString]); nextPutAll: '.'].
			aStream crtab; crtab; nextPutAll: '!!'].
	aStream nextPutAll: ' !!';
		 cr ]! !

!SDLCodeGenerator methodsFor: 'FFI code generation' stamp: 'NickAlexander 1/1/2012 18:02'!
structsInto: aStream forClass: aClassName 
	self subclassResponsibility! !

!SDLCodeGenerator methodsFor: 'FFI code generation' stamp: 'NickAlexander 1/8/2012 19:06'!
writeFileInsToDirectory: aString
	self
		constantsInto: (FileStream forceNewFileNamed: aString, self prefixString, 'SDLConstants.st')
		forClass: 'SDLConstants'.
	self
		handlesInto: (FileStream forceNewFileNamed: aString, self prefixString, 'SDLHandles.st')
		forClass: 'SDLLibrary'.
	self
		structsInto: (FileStream forceNewFileNamed: aString, self prefixString, 'SDLStructs.st')
		forClass: 'SDLLibrary'.
	self
		functionsInto: (FileStream forceNewFileNamed: aString, self prefixString, 'SDLFunctions.st')
		forClass: 'SDLLibrary'.
	self
		loaderInto: 	(FileStream forceNewFileNamed: aString, self prefixString, 'SDL.st')
		forDirectory: aString.! !

Object subclass: #SDLSpec
	instanceVariableNames: 'name headerFileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SDL-Specs-Core'!

SDLSpec subclass: #SDLEnumSpec
	instanceVariableNames: 'valueNames counter isHex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SDL-Specs-Core'!

!SDLEnumSpec methodsFor: 'as yet unclassified' stamp: ''!
add: aName 
	valueNames at: aName put: counter.
	counter := counter + 1! !

!SDLEnumSpec methodsFor: 'as yet unclassified' stamp: ''!
add: aName value: value 
	valueNames at: aName put: value.
	counter := value + 1.
	isHex := true! !

!SDLEnumSpec methodsFor: 'as yet unclassified' stamp: ''!
indexesAndSuffixesDo: aBlockClosure 
	valueNames size < 100
		ifTrue: [aBlockClosure value: 1 value: ''.
			^ self].
	(1 to: valueNames size by: 100)
		doWithIndex: [:v :i | aBlockClosure value: v value: i asString]! !

!SDLEnumSpec methodsFor: 'as yet unclassified' stamp: ''!
initialize
	counter := 0.
	isHex := false.
	valueNames := OrderPreservingDictionary new! !

!SDLEnumSpec methodsFor: 'as yet unclassified' stamp: ''!
isHex
	^ isHex! !

!SDLEnumSpec methodsFor: 'accessing' stamp: ''!
parse: xml 
	super parse: xml.
	xml // #expr
		do: [:e | self parseEnumValue: e]! !

!SDLEnumSpec methodsFor: 'accessing' stamp: ''!
parseEnumValue: xml 
	| nm value |
	nm := (xml / #name) getContentAsString.
	xml stringNodes isEmpty
		ifTrue: [self add: nm]
		ifFalse: [value := SqNumberParser
						parse: ((' ' split: ('=' split: xml stringNodes last string) last) last copyReplaceAll: '0x' with: '16r').
			self add: nm value: value]! !

!SDLEnumSpec methodsFor: 'accessing' stamp: ''!
valueNames
	^ valueNames! !

!SDLEnumSpec methodsFor: 'accessing' stamp: ''!
valueNames: anObject 
	valueNames := anObject! !

SDLSpec subclass: #SDLFunctionSpec
	instanceVariableNames: 'returnType params'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SDL-Specs-Core'!

!SDLFunctionSpec methodsFor: 'accessing' stamp: ''!
initialize
	params := OrderPreservingDictionary new! !

!SDLFunctionSpec methodsFor: 'accessing' stamp: ''!
params
	^ params! !

!SDLFunctionSpec methodsFor: 'accessing' stamp: ''!
params: anObject 
	params := anObject! !

!SDLFunctionSpec methodsFor: 'accessing' stamp: ''!
parse: xml 
	self name: (xml / #name) getContentAsString.
	self parseReturnType: xml / #type.
	xml // #param
		do: [:e | self parseParam: e / #decl]! !

!SDLFunctionSpec methodsFor: 'accessing' stamp: ''!
parseParam: e 
	| nm type a |
	nm := (e / #name) getContentAsString.
	type := self checkUnderscores: (e // #type) getContentAsString.
	nm isEmpty
		ifFalse: [params at: nm put: type]! !

!SDLFunctionSpec methodsFor: 'accessing' stamp: ''!
parseReturnType: xml 
	| rt |
	rt := self checkUnderscores: xml getContentAsString.
	self returnType: rt! !

!SDLFunctionSpec methodsFor: 'accessing' stamp: ''!
returnType
	^ returnType! !

!SDLFunctionSpec methodsFor: 'accessing' stamp: ''!
returnType: anObject 
	returnType := anObject! !

!SDLFunctionSpec methodsFor: 'code generation' stamp: ''!
underscoreCheck: aString 
	^ aString! !

!SDLSpec methodsFor: 'accessing' stamp: ''!
checkUnderscores: s 
	| type a |
	type := s.
	type := type copyReplaceAll: 'struct' with: ''.
	type := type copyReplaceAll: 'const' with: ''.
	type := type copyReplaceAll: ' ' with: ''.
	type := type copyReplaceAll: 'extern' with: ' '.
	type := type copyReplaceAll: 'DECLSPEC' with: ' '.
	type := type copyReplaceAll: 'SDLCALL' with: ' '.
	a := Array
				with: Character lf
				with: Character tab
				with: Character cr
				with: Character space.
	type := type
				reject: [:f | a includes: f].
	^ type! !

!SDLSpec methodsFor: 'accessing' stamp: ''!
headerFileName
	^ headerFileName! !

!SDLSpec methodsFor: 'accessing' stamp: ''!
headerFileName: anObject 
	headerFileName := anObject! !

!SDLSpec methodsFor: 'accessing' stamp: ''!
name
	^ name! !

!SDLSpec methodsFor: 'accessing' stamp: ''!
name: anObject 
	name := anObject! !

!SDLSpec methodsFor: 'accessing' stamp: ''!
parse: xml 
	self name: (xml parent parent / #name) getContentAsString.
	self name isEmpty
		ifTrue: [self halt.
			^ self]! !

SDLSpec subclass: #SDLStructSpec
	instanceVariableNames: 'valueNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SDL-Specs-Core'!

!SDLStructSpec methodsFor: 'as yet unclassified' stamp: ''!
add: aName value: value 
	valueNames at: aName put: value! !

!SDLStructSpec methodsFor: 'as yet unclassified' stamp: ''!
initialize
	valueNames := OrderPreservingDictionary new! !

!SDLStructSpec methodsFor: 'accessing' stamp: ''!
parse: xml 
	super parse: xml.
	xml // #decl
		do: [:e | self parseDecl: e]! !

!SDLStructSpec methodsFor: 'accessing' stamp: ''!
parseDecl: xml 
	| type nm |
	type := self checkUnderscores: (xml / #type) getContentAsString.
	xml / #name
		do: [:e | e stringNodes isEmpty
				ifTrue: ['misses 3: text editing events and SDL_PixelFormat padding ']
				ifFalse: [nm := e stringNodes last string.
					self add: nm value: type]]! !

!SDLStructSpec methodsFor: 'accessing' stamp: ''!
valueNames
	^ valueNames! !

!SDLStructSpec methodsFor: 'accessing' stamp: ''!
valueNames: anObject 
	valueNames := anObject! !

SDLStructSpec subclass: #SDLUnionSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SDL-Specs-Core'!
